//+---------------------------------------------------------------------+
//|                                                        JMASlope.mq5 |
//|                       Copyright  2005, Weld & TrendLaboratory Ltd. |
//|               http://finance.groups.yahoo.com/group/TrendLaboratory |
//+---------------------------------------------------------------------+ 
//|     SmoothAlgorithms.mqh      |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2005, Weld & TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"
//---   
#property version   "1.00"
//---     
#property indicator_separate_window 
//---    2
#property indicator_buffers 2 
//---     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//---      
#property indicator_type1 DRAW_COLOR_HISTOGRAM
//---      
#property indicator_color1 clrMagenta,clrPurple,clrGray,clrBlue,clrDodgerBlue
//---   - 
#property indicator_style1 STYLE_SOLID
//---     2
#property indicator_width1 2
//---   
#property indicator_label1 "JMASlope"
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum Applied_price_      //  
  {
   PRICE_CLOSE_ = 1,     // Close
   PRICE_OPEN_,          // Open
   PRICE_HIGH_,          // High
   PRICE_LOW_,           // Low
   PRICE_MEDIAN_,        // Median Price (HL/2)
   PRICE_TYPICAL_,       // Typical Price (HLC/3)
   PRICE_WEIGHTED_,      // Weighted Close (HLCC/4)
   PRICE_SIMPL_,         // Simple Price (OC/2)
   PRICE_QUARTER_,       // Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  // TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_,  // TrendFollow_2 Price 
   PRICE_DEMARK_         // Demark Price
  };
//+-----------------------------------+
//|         |
//+-----------------------------------+
input int jLength=14;                  //                     
input int jPhase=0;                    //  
input Applied_price_ IPC=PRICE_CLOSE_; //  
input int Shift=0;                     //      
//+-----------------------------------+
//---      
int min_rates_total;
//---   ,   
//---      
double IndBuffer[],ColorIndBuffer[];
//+------------------------------------------------------------------+
//|   iPriceSeries()                                  |
//|   iPriceSeriesAlert()                             |
//|   CJJMA                                            |
//+------------------------------------------------------------------+ 
#include <SmoothAlgorithms.mqh> 
//+------------------------------------------------------------------+    
//| JMASlope indicator initialization function                       | 
//+------------------------------------------------------------------+  
void OnInit()
  {
//---     
   min_rates_total=30+2;
//---    IndBuffer   
   SetIndexBuffer(0,IndBuffer,INDICATOR_DATA);
//---      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0.0);
//---       Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//---     ,     
   SetIndexBuffer(1,ColorIndBuffer,INDICATOR_COLOR_INDEX);
//---    CJJMA   JJMASeries_Cls.mqh
   CJJMA JMA;
//---       
   JMA.JJMALengthCheck("jLength",jLength);
//---       
   JMA.JJMAPhaseCheck("jPhase",jPhase);
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,"JMASlope");
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//---  
  }
//+------------------------------------------------------------------+  
//| JMASlope iteration function                                      | 
//+------------------------------------------------------------------+  
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double& high[],     //       
                const double& low[],      //        
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(rates_total<min_rates_total) return(0);
//---   
   int first,bar;
//---       
   double series,j1jma,djjma;
   static double prev_j1jma;

   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=1; //      
      prev_j1jma=0;
     }
   else first=prev_calculated-1; //      

//---    JJMA   JJMASeries_Cls.mqh
   static CJJMA JMA;
//---    
   for(bar=first; bar<rates_total && !IsStopped(); bar++)
     {
      //---    PriceSeries     Series
      series=PriceSeries(IPC,bar,open,low,high,close);
      //---    JJMASeries. 
      //---  Phase_  Length_      (Din=0) 
      j1jma=JMA.JJMASeries(1,prev_calculated,rates_total,0,jPhase,jLength,series,bar,false);
      //---
      djjma=(j1jma-prev_j1jma)/_Point;
      IndBuffer[bar]=djjma;
      //---
      if(bar!=rates_total-1) prev_j1jma=j1jma;
      //---
      ColorIndBuffer[bar]=2;
      //---
      if(djjma>0)
        {
         if(djjma>IndBuffer[bar-1]) ColorIndBuffer[bar]=4;
         if(djjma<IndBuffer[bar-1]) ColorIndBuffer[bar]=3;
        }
      //---
      if(djjma<0)
        {
         if(djjma<IndBuffer[bar-1]) ColorIndBuffer[bar]=0;
         if(djjma>IndBuffer[bar-1]) ColorIndBuffer[bar]=1;
        }
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
